IDA SDK

- Main Page
- Header Files
- Classes
- Modules

Functions
Functions: built-in choosers

## Detailed Description

Convenience functions for ui_choose and choose_type_t.

## Functions
char * | choose_idasgn (void)
| Choose a signature (ui_choose, chtype_idasgn). More...
bool | choose_til (char *buf, size_t bufsize)
| Choose a type library (ui_choose, chtype_idatil). More...
ea_t | choose_entry (const char *title)
| Choose an entry point (ui_choose, chtype_entry). More...
ea_t | choose_name (const char *title)
| Choose a name (ui_choose, chtype_name). More...
ea_t | choose_stkvar_xref (func_t *pfn, member_t *mptr)
| Choose an xref to a stack variable (ui_choose, chtype_name). More...
ea_t | choose_xref (ea_t to)
| Choose an xref to an address (ui_choose, chtype_xref). More...
enum_t | choose_enum (const char *title, enum_t default_id)
| Choose an enum (ui_choose, chtype_enum). More...
enum_t | choose_enum_by_value (const char *title, enum_t default_id, uval_t value, int nbytes, uchar *serial)
| Choose an enum, restricted by value & size (ui_choose, chtype_enum_by_value_and_size). More...
func_t * | choose_func (const char *title, ea_t default_ea)
| Choose a function (ui_choose, chtype_func). More...
segment_t * | choose_segm (const char *title, ea_t default_ea)
| Choose a segment (ui_choose, chtype_segm). More...
struc_t * | choose_struc (const char *title)
| Choose a structure (ui_choose, chtype_segm). More...
segreg_area_t * | choose_srcp (const char *title)
| Choose a segment register change point (ui_choose, chtype_srcp). More...

## Function Documentation

char* choose_idasgn | ( | void |  | ) |
| inline

Choose a signature (ui_choose, chtype_idasgn).

Returns
  name of selected signature, NULL if none selected

bool choose_til | ( | char * | buf,
|  | size_t | bufsize
| ) |  |
| inline

Choose a type library (ui_choose, chtype_idatil).

Parameters

  buf | output buffer to store the library name
  bufsize | size of output buffer

Return values

  true | 'buf' was filled with the name of the selected til
  false | otherwise

ea_t choose_entry | ( | const char * | title | ) |
| inline

Choose an entry point (ui_choose, chtype_entry).

Parameters

  title | chooser title

Returns
  ea of selected entry point, BADADDR if none selected

ea_t choose_name | ( | const char * | title | ) |
| inline

Choose a name (ui_choose, chtype_name).

Parameters

  title | chooser title

Returns
  ea of selected name, BADADDR if none selected

ea_t choose_stkvar_xref | ( | func_t * | pfn,
|  | member_t * | mptr
| ) |  |
| inline

Choose an xref to a stack variable (ui_choose, chtype_name).

Parameters

  pfn | function
  mptr | variable

Returns
  ea of the selected xref, BADADDR if none selected

ea_t choose_xref | ( | ea_t | to | ) |
| inline

Choose an xref to an address (ui_choose, chtype_xref).

Parameters

  to | referenced address

Returns
  ea of selected xref, BADADDR if none selected

enum_t choose_enum | ( | const char * | title,
|  | enum_t | default_id
| ) |  |
| inline

Choose an enum (ui_choose, chtype_enum).

Parameters

  title | chooser title
  default_id | id of enum to select by default

Returns
  enum id of selected enum, BADNODE if none selected

enum_t choose_enum_by_value | ( | const char * | title,
|  | enum_t | default_id,
|  | uval_t | value,
|  | int | nbytes,
|  | uchar * | serial
| ) |  |
| inline

Choose an enum, restricted by value & size (ui_choose, chtype_enum_by_value_and_size).

If the given value cannot be found initially, this function will ask if the user would like to import a standard enum.

Parameters

  | title | chooser title
  | default_id | id of enum to select by default
  | value | value to search for
  | nbytes | size of value
  [out] | serial | serial number of imported enum member, if one was found

Returns
  enum id of selected (or imported) enum, BADNODE if none was found

func_t* choose_func | ( | const char * | title,
|  | ea_t | default_ea
| ) |  |
| inline

Choose a function (ui_choose, chtype_func).

Parameters

  title | chooser title
  default_ea | ea of function to select by default

Returns
  pointer to function that was selected, NULL if none selected

segment_t* choose_segm | ( | const char * | title,
|  | ea_t | default_ea
| ) |  |
| inline

Choose a segment (ui_choose, chtype_segm).

Parameters

  title | chooser title
  default_ea | ea of segment to select by default

Returns
  pointer to segment that was selected, NULL if none selected

struc_t* choose_struc | ( | const char * | title | ) |
| inline

Choose a structure (ui_choose, chtype_segm).

Parameters

  title | chooser title;

Returns
  pointer to structure that was selected, NULL if none selected

segreg_area_t* choose_srcp | ( | const char * | title | ) |
| inline

Choose a segment register change point (ui_choose, chtype_srcp).

Parameters

  title | chooser title

Returns
  pointer to segment register area of selected change point, NULL if none selected